<template lang="pug">
.row.x-containerinfo
  .col-12.py-3.justify-content-center.d-flex(v-if='!loading && $butils.isNil(container)' key='noSuch')
    span.alert.alert-secondary Unknown Container
  .col-12(v-if='container' key='container')
    BaseCard
      template(v-slot:header='')
        BaseAnimationBlock
          .justify-content-center.d-flex(v-if='loading' key='loading')
            h1 #[i.align-bottom.fa.fa-spinner.fa-pulse]
          .d-flex.justify-content-between.align-items-center(v-else key='title')
            h5 Container #[span.text-muted {{ "#" + container.id }}]
            router-link.text-dark.text-muted.clickable.ml-1(:to='getRoute("/containers")')
              .fa.fa-caret-up
            .ml-auto.clickable(@click='setEdit(true)' v-if='canEdit && !inEdit')
              kbd.keyHint.mr-2(v-if="showKeyHints") E
              i.fa.fa-cog
            .ml-auto.clickable(@click='setEdit(false)' v-if='canEdit && inEdit')
              kbd.keyHint.mr-2(v-if="showKeyHints") Esc
              i.fa.fa-times
      li(v-if='!containerLoading && !inEdit' key='info')
        mixin info(name)
          .row&attributes(attributes)
            .col-12.text-left.col-sm-3.col-lg-2
              strong= name
            .col-12.text-right.col-sm-9.col-lg-10.text-sm-left
              block
        +info('Id') {{ container.id }}
        +info('Name') {{ container.name }}
        +info('TREC Number') {{ container.trecNumber }}
      li(v-if='!containerLoading && inEdit' key='edit')
        .row.b-param-container
          BaseParamInput.col-12.col-sm-9(ref='name' title='Name' :inEdit='true' :value='container.name')
          BaseParamInput.col-12.col-sm-6.col-lg-4(ref='trecNumber' type='number' step='1'
            title='TREC Number' :inEdit='true' :value='container.trecNumber')
      li.px-0.pt-0.x-desc(v-if='!containerLoading' key='desc')
        BaseMarkdownWidget(ref='description' :inEdit='inEdit' :value='container.description')
      li.x-setups(v-if='!setupsLoading' key='setups')
        DBCollapsible(title='Detector Setups' source='detectorsSetups' parentType='containers' :parentItem='container' :query='{ sort: "id:desc" }')
          template(v-slot:row='row')
            router-link.text-primary.text-truncate(:key='row.id' :to='getRoute(`/detectors/setups/${row.id}`)') {{ row.name }}
      li(v-if='!loading && inEdit' key='submit')
        .d-flex.justify-content-end
          button.btn.btn-danger.mx-1.x-delete(v-if='isAdmin' @click="doDelete()" title='Delete Container')
            i.fa.fa-trash
          router-link.btn.btn-outline-danger.ml-1.x-admin(v-if='!isAdmin && $store.getters.canAdmin' :to='"/admin" + $route.fullPath' title='admin')
            i.fa.fa-key
          button.btn.btn-primary.mx-1.x-submit(@click="doSubmit()")
            kbd.keyHint.mr-2(v-if="showKeyHints") Ctrl+S
            i.fa.fa-upload.mr-1(v-else)
            | Submit
        BaseDialog(v-if='isAdmin' ref='deleteDialog' title='Delete Container')
          template(v-if='!$butils.isEmpty(setups)')
            p This container is used in some setups.
            p.mb-0 It must be removed from all setups.
          template(v-else)
            p This will permanently delete the container.
            p.mb-0 do you confirm this action ?
          template(v-slot:footer='d')
            button.btn.btn-primary(v-if='!$butils.isEmpty(setups)'
              @click='d.resolve(false)') Cancel
            template(v-else)
              button.mr-1.btn.btn-secondary(@click='d.resolve(false)') Cancel
              button.btn.btn-danger(@click='d.resolve(true)') Ok
</template>
<script>
export { default } from './ContainerInfo.vue.js';
</script>
<style lang='scss'>
.x-containerinfo {
  .b-markdown-preview {
    padding-top: .75rem;
    padding-left: 15px;
    padding-right: 15px;
  }
  .x-desc {
    // preview ribbon must be over other elts
    z-index: 1;
  }
}
</style>
